"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transient = exports.Singleton = void 0;
var Singleton = /** @class */ (function () {
    function Singleton(futureProvider, dependency, providerName, factoryFunction) {
        this.provider = futureProvider;
        this.dependency = dependency;
        this.providerName = providerName;
        this.factoryFunction = factoryFunction;
    }
    Singleton.prototype.provide = function () {
        return this.value || (this.value = this.factoryFunction(this.provider()));
    };
    return Singleton;
}());
exports.Singleton = Singleton;
var Transient = /** @class */ (function () {
    function Transient(futureProvider, dependency, providerName, factoryFunction) {
        this.futureProvider = futureProvider;
        this.dependency = dependency;
        this.providerName = providerName;
        this.factory = factoryFunction;
    }
    Transient.prototype.provide = function () {
        return this.factory(this.futureProvider());
    };
    return Transient;
}());
exports.Transient = Transient;
